#<profile4xi profile = "31"/>
# ------------------------------------------------------------------------------------------------
#<program4xi program = "test_resourcesharer4xi.py">
#<abstract4xi abstract = "tests resourcesharer4xi"/>
#<verify4xi verification = "10" target = "resourcesharer4xi.py"/>
#<contextualize4xi context = "resourcesharer4xi.py"/>
#<use4xi usage = "
#
# SELECT:
# 1) ack2test4original = True <-- SENSING ORIGINAL RESOURCESHARER
# 2) ack2test4xi = True <-- SENSING RESOURCESHARER4XI
# -note: yoy can select either 1) or 2) because a server is activated
# 
# RUN:
# 1) > call t  test_resourcesharer4xi > ..\txt\test_resourcesharer4xi.txt
# 2) > call t test_noun4xi > ..\txt\test_noun4xi.txt <-- set ace-test-resourcesharer4xi.xml': 'nack' in test_noun4xi.py 
#
# ANALYZE:
# scope-ace-test-resourcesharer4xi.xml <-- scope file (make sure test_noun4xi.py setting is ok)
# sense-test-resourcesharer4xi.xml     <-- trace in XML
# reason-test-resourcesharer4xi.xml
# ace-test-resourcesharer4xi.xml
# test_resourcesharer4xi.txt           <-- textual trace
#"/>
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'test_resourcesharer4xi' ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import _winapi

# -------------------------------------------------------------------------------------------------
# imports specially for this module
# -------------------------------------------------------------------------------------------------

#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from resourcesharer4xi import ResourceSharer4Xi 

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>
# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'Client4Xi': 'NACK4TRACE',
         'duplicate4xi': 'NACK4TRACE',
         'is_exiting4xi': 'NACK4TRACE',        
         'Listener4Xi': 'NACK4TRACE',
         'PipeConnection4Xi': 'NACK4TRACE',
         'PipeListener4Xi': 'NACK4TRACE',
         'ResourceSharer4Xi': 'NACK4TRACE',
         '_exit_function4xi': 'NACK4TRACE'
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>                  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "print2trace4xi" usage = "
#   creates XML files
#">                       
# -------------------------------------------------------------------------------------------------    
def print2trace4xi(p2xi):
    global t2xi
    global trace_object_count   

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-resourcesharer4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Server in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Server in Multiprocessing.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(p2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-resourcesharer4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Server in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Server in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(p2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-resourcesharer4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Server in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Server in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(p2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi> 

 
# -------------------------------------------------------------------------------------------------
#<function function = "test2resourcesharer" usage = "
#   testing resourcesharer
#<state status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#">     
# -------------------------------------------------------------------------------------------------
def test2resourcesharer():
    print("\n (STEP 1A/4) OF TEST_RESOURCESHARER - STARTING TESTING RESOURCESHARER ", time4xi())
    try:
    
        # ---------------------------------------------------------------------------------------------
        # (STEP 1/4) - PASSED
        # ---------------------------------------------------------------------------------------------  
        print("\n (STEP 1B/4) OF TEST_RESOURCESHARER - CREATING RESOURCESHARER ", time4xi())        
        # 
        
        resourcesharer2xi = ResourceSharer4Xi()
        
        print("\n (STEP 1B/4) OF TEST_RESOURCESHARER - INITIALIZED RESOURCESHARER: ", resourcesharer2xi) 
        # 
        
        # ---------------------------------------------------------------------------------------------
        # (STEP 2/4) - PASSED
        # ---------------------------------------------------------------------------------------------  
        print("\n (STEP 2A/4) OF TEST_RESOURCESHARER - STARTING RESOURCESHARER OBJECT ", time4xi())  
        # 
                     
        resourcesharer2xi._start()
    
        
        print("\n (STEP 2B/4) OF TEST_RESOURCESHARER - STARTED RESOURCESHARER OBJECT ", time4xi()) 
        # 
        
        # ---------------------------------------------------------------------------------------------
        # (STEP 3/4) - STARTED BUT DID NOT PASSED
        # ---------------------------------------------------------------------------------------------  
        print("\n (STEP 3A/4) OF TEST_RESOURCESHARER - SERVING WITH RESOURCESHARER OBJECT ", time4xi())  
        # 
                     
        resourcesharer2xi._serve()
        
        print("\n (STEP 3B/4) OF TEST_RESOURCESHARER - SERVED WITH RESOURCESHARER OBJECT ", time4xi())          
        
        # ---------------------------------------------------------------------------------------------
        # (STEP 4/4) - DID NOT COME HERE!
        # ---------------------------------------------------------------------------------------------  
        print("\n (STEP 4A/4) OF TEST_RESOURCESHARER - STOP SERVING WITH RESOURCESHARER OBJECT ", time4xi()) 
                      
        resourcesharer2xi._stop()
        
        print("\n (STEP 4B/4) OF TEST_RESOURCESHARER - STOPPED SERVING WITH RESOURCESHARER OBJECT ", time4xi())             
    except:        
        print("\n (STEP 1Z/4) OF TEST_RESOURCESHARER *** FAILED IN TESTING RESOURCESHARER ", time4xi())
               
    
#</function>     
           

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test2resourcesharer4xi" usage = "
#   testing resourcesharer4xi
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#">     
# -------------------------------------------------------------------------------------------------
def test2resourcesharer4xi():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0A/33) OF TEST_RESOURCESHARER4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
    
        # ---------------------------------------------------------------------------------------------
        # (STEP 1/4) - PASSED
        # ---------------------------------------------------------------------------------------------  
        print("\n (STEP 1A/4) OF TEST_RESOURCESHARER4XI - CREATING RESOURCESHARER2XI ", time4xi())        
        # 15:29:48 03/14/13 FLE Standard Time
        
        resourcesharer2xi = ResourceSharer4Xi()
        
        print("\n (STEP 1B/4) OF TEST_RESOURCESHARER4XI - INITIALIZED RESOURCESHARER2XI: ", resourcesharer2xi) 
        # <resourcesharer4xi.ResourceSharer4Xi object at 0x00000000030A4F98>
        
        # ---------------------------------------------------------------------------------------------
        # (STEP 2/4) - PASSED
        # ---------------------------------------------------------------------------------------------  
        print("\n (STEP 2A/4) OF TEST_RESOURCESHARER4XI - STARTING RESOURCESHARER2XI OBJECT ", time4xi())  
        # 15:29:48 03/14/13 FLE Standard Time
                     
        resourcesharer2xi._start()
    
        
        print("\n (STEP 2B/4) OF TEST_RESOURCESHARER4XI - STARTED RESOURCESHARER2XI OBJECT ", time4xi()) 
        # 15:29:48 03/14/13 FLE Standard Time
        
        # ---------------------------------------------------------------------------------------------
        # (STEP 3/4) - STARTED - DID NOT PASS!
        # ---------------------------------------------------------------------------------------------  
        print("\n (STEP 3A/4) OF TEST_RESOURCESHARER4XI - SERVING WITH RESOURCESHARER2XI OBJECT ", time4xi())  
        # 15:29:48 03/14/13 FLE Standard Time
                     
        resourcesharer2xi._serve()
        
        print("\n (STEP 3B/4) OF TEST_RESOURCESHARER4XI - SERVED WITH RESOURCESHARER2XI OBJECT ", time4xi())          
        
        # ---------------------------------------------------------------------------------------------
        # (STEP 4/4) - DID NOT COME HERE!
        # ---------------------------------------------------------------------------------------------  
        print("\n (STEP 4A/4) OF TEST_RESOURCESHARER4XI - STOP SERVING WITH RESOURCESHARER2XI OBJECT ", time4xi()) 
                      
        resourcesharer2xi._stop()
        
        print("\n (STEP 4B/4) OF TEST_RESOURCESHARER4XI - STOPPED SERVING WITH RESOURCESHARER2XI OBJECT ", time4xi())             
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace - whatever happened
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(t2xi)        
               
    
#</function4xi>     
           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   testing resourcesharer4xi
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#">     
# -------------------------------------------------------------------------------------------------
def main(args=(), kwds={}):

    ack2test4original = False
    if ack2test4original is True:
        print("SENSING ORIGINAL RESOURCESHARER ", time4xi())  
        test2resourcesharer()
        print("SENSED ORIGINAL RESOURCESHARER ", time4xi())  
    else:
        print("SKIPPED SENSING ORIGINAL RESOURCESHARER ", time4xi())      
    
    ack2test4xi = True    
    if ack2test4xi is True:  
        print("SENSING RESOURCESHARER4XI ", time4xi())  
        test2resourcesharer4xi()
        print("SENSED RESOURCESHARER4XI ", time4xi())  
    else:
        print("SKIPPED SENSING RESOURCESHARER4XI ", time4xi())      
        
    
#</function4xi> 


# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':

    main(args=(), kwds={})


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_resourcesharer4xi.txt          # note: test_server_mp_xi4 tests more featueres
#   sense-test-resourcesharer4xi.xml    # note: more in sense ace-resourcesharer4xi.xml
#   reason-test-resourcesharer4xi.xml   # note: more in reason ace-resourcesharer4xi.xml
#   ace-test-resourcesharer4xi.xml      # note: more in ace ace-resourcesharer4xi.xml

#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_resourcesharer4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

